<!doctype html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>PYTHON - GIL, Threads, Asyncio</title>

		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/quantlane.css">


		<script src="lib/js/mermaid.min.js"></script>

		<style type="text/css">
			section > img {
				border: none !important;
				box-shadow: none !important;
			}

			section pre {
				width: 100% !important;
			}

			section pre code {
				max-height: 100% !important;
			}

			section[data-background-image] h2,
			section[data-background-image] h3 {
				background: rgba(0, 0, 0, 0.7);
			}

			code mark, code mark span{
				color: black !important;
			}


			section[data-background-image] h2,
			section[data-background-image] h3 {
				color: white;
			}

			h2 + a, h3 + a {
				display: block;
				margin-top: -1em !important;
				font-size: 60% !important;
			}

			.reveal .diagram-display {
			  padding: 0;
			  margin: 2em 0 0;
			  min-height: 700px;
			  min-width:100%;
			  height:auto;
			}
		</style>


		<style type="text/css">
			
		</style>

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/zenburn.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
		</script>
	</head>
	<body>
		<div class="reveal">
			<div class="slides">

				<section data-transition="fade-in fade-out" class="intro-slide">
					<img class="logo" src="img/logo-white.png" alt="Quantlane">
					<h2>PYTHON - GIL, Threads, Asyncio</h2>
					<h4>Libor Jonát</h4>

					
						<aside class="notes">
							<ul>
							
								<li>I would like it interactive</li>
							
								<li>Today we will talk about CPython</li>
							
								<li>What is benefit of Python</li>
							
								<li>What is bad about Python</li>
							
							</ul>
						</aside>
					
				</section>

				
					
						
						<section  data-transition="fade-in fade-out" class="category-0 " ">
	
		<h3 >About me / Quantlane</h3>
	

	
		
		<ul>
			
				
					<li>I work as software engineer in Quantlane</li>
				
			
				
					<li>Writing stock trading application which is almost whole in Python</li>
				
			
				
					<li>Using Python almost everywhere</li>
				
			
		</ul>
		
	

	

	

	

	
</section>
					
						
						<section  data-transition="fade-in fade-out" class="category-0 " ">
	
		<h3 >Big Buck Bunny</h3>
	

	
		
		<ul>
			
				
					<li>This repository contains the Big Buck Bunny https://peach.blender.org/about/ movie converted to ASCII art frames.</li>
				
			
				
					<li>https://github.com/hit9/img2txt was used to convert each video frame to ASCII art.</li>
				
			
		</ul>
		
	

	

	

	

	
</section>
					
						
						<section  data-transition="fade-in fade-out" class="category-0 " ">
	
		<h3 >Talk goals</h3>
	

	
		
		<ul>
			
				
					<li>https://gitlab.com/libor.jonat/ds-advanced-python</li>
				
			
				
					<li>What is GIL in CPython</li>
				
			
				
					<li>Threads usability in CPython</li>
				
			
				
					<li>Basic knowledge of Asyncio</li>
				
			
				
					<li>Understanding what are generators good for</li>
				
			
		</ul>
		
	

	

	

	

	
</section>
					
				

				<section data-transition="fade-in fade-out" data-background-image="img/wallpaper.svg"></section>

				

				
					

					
						
						<section  data-transition="fade-in fade-out" class="category-0 " ">
	
		<h3 >Global interpreter lock (GIL)</h3>
	

	
		
		<ul>
			
				
					<li>Source: https://callhub.io/understanding-python-gil/</li>
				
			
		</ul>
		
	

	
		<img src="https://callhub.io/wp-content/uploads/2016/06/python-gil-visualization.png">
	

	

	

	
		<aside class="notes">
			<ul>
			
				<li>IO bound thread can wait in parallel</li>
			
				<li>Only one CPU bound thread can run</li>
			
				<li>Why it is a problem?</li>
			
			</ul>
		</aside>
	
</section>
					
						
						<section  data-transition="fade-in fade-out" class="category-0 " ">
	
		<h3 >Example: Threads</h3>
	

	
		
		<ul>
			
				
					<li>Simple HTTP server writen in Python</li>
				
			
				
					<li>Showcase why GIL is a problem</li>
				
			
				
					<li>Not recomendet way to write web server</li>
				
			
				
					<li>Also for files you should use nginx or different server</li>
				
			
		</ul>
		
	

	

	

	

	
		<aside class="notes">
			<ul>
			
				<li>Thread cancelation</li>
			
			</ul>
		</aside>
	
</section>
					
						
						<section  data-transition="fade-in fade-out" class="category-0 " ">
	
		<h3 >Asyncio Basics and generators</h3>
	

	

	

	

	

	
</section>
					
						
						<section  data-transition="fade-in fade-out" class="category-0 " ">
	
		<h3 >Rewrite server using asyncio</h3>
	

	
		
		<ul>
			
				
					<li>aiohttp, sessions, handling etc...</li>
				
			
				
					<li>Mesurable performance boost</li>
				
			
				
					<li>Why?</li>
				
			
				
					<li>Still not perfect - file descriptors</li>
				
			
		</ul>
		
	

	

	

	

	
</section>
					
						
						<section  data-transition="fade-in fade-out" class="category-0 " ">
	
		<h3 >Example: Asyncio web player</h3>
	

	

	

	

	

	
		<aside class="notes">
			<ul>
			
				<li>queue used for buffering frames</li>
			
				<li>max size used to limit memory</li>
			
				<li>not perfect to use http</li>
			
			</ul>
		</aside>
	
</section>
					
				


				<section data-transition="fade-in fade-out" class="thankyou-slide" data-background-color="#000000">
					<img class="logo" src="img/logo-black.png" alt="Quantlane">
					<br>

					<a href="libor@quantlane.com"><span class="email-name">libor@</span>quantlane.com</a>
				</section>


			</div>
		</div>

		<script src="lib/js/head.min.js"></script>
		<script src="js/reveal.js"></script>

		<script>
			// More info https://github.com/hakimel/reveal.js#configuration
			Reveal.initialize({
				history: true,

				controls: false,
				controlsBackArrows: 'hidden',
				progress: false,

				// More info https://github.com/hakimel/reveal.js#dependencies
				dependencies: [
					{ src: 'plugin/markdown/marked.js' },
					{ src: 'plugin/markdown/markdown.js' },
					{ src: 'plugin/notes/notes.js', async: true },
					{ src: 'plugin/highlight/highlight.js', async: true, callback: function() { hljs.initHighlightingOnLoad(); } },
					{ src: 'plugin/mermaid/mermaid.js' }
				]
			});
		</script>
	</body>
</html>
